#include <bits/stdc++.h>
using namespace std;
#define int long long

const int N = 1e5 + 5;
const int C = 20;

struct Node {
    int suff, pref, sum;
};

vector<int> a(N);

vector<int> tree(N * 4), tree2(N * 4);
vector<int> u (N * 4, 0), u2(N * 4, 0);

vector<pair<int, int>> tree_mx(N * 4, {0, -1});


void push_pref(int v, int tl, int tr) {
    if (u[v] == 0) return;
    tree[v] = (tr - tl + 1) * u[v];
    if (tl != tr) {
        u[2 * v + 1] = u[v];
        u[2 * v + 2] = u[v];
    }
    u[v] = 0;
}
void push_suff(int v, int tl, int tr) {
    if (u2[v] == 0) return;
    tree2[v] = (tr - tl + 1) * u2[v];
    if (tl != tr) {
        u2[2 * v + 1] = u2[v];
        u2[2 * v + 2] = u2[v];
    }
    u2[v] = 0;
}


void build (int v, int tl, int tr) {
    if (tl == tr) {
        tree[v] = a[tl];
        tree2[v] = a[tl];
        tree_mx[v] = {a[tl], tl};
        return;
    }
    int tm = (tl + tr) / 2;
    build (2 * v + 1, tl, tm);
    build (2 * v + 2, tm + 1, tr);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    tree2[v] = tree2[2 * v + 1] + tree2[2 * v + 2];
    tree_mx[v] = max(tree_mx[2 * v + 1], tree_mx[2 * v + 2]);
}

void update (int v, int tl, int tr, int l, int r, int val) {
    push_pref(v, tl,tr);
    push_suff(v, tl, tr);
    if (l > tr || r < tl) return;
    if (l <= tl && tr <= r) {
        u[v] = val;
        push_pref(v, tl, tr);
        return;
    }
    int tm = (tl + tr) / 2;
    update (2 * v + 1, tl, tm, l, r, val);
    update(2 * v + 2, tm + 1, tr, l, r, val);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

void update2 (int v, int tl, int tr, int l, int r, int val) {
    push_pref(v, tl, tr);
    push_suff(v, tl,tr);
    if (l > tr || r < tl) return;
    if (l <= tl && tr <= r) {
        u2[v] = val;
        push_suff(v, tl, tr);
        return;
    }
    int tm = (tl + tr) / 2;
    update2 (2 * v + 1, tl, tm, l, r, val);
    update2(2 * v + 2, tm + 1, tr, l, r, val);
    tree2[v] = tree2[2 * v + 1] + tree2[2 * v + 2];
}

int get (int v, int tl, int tr ,int l, int r) {
    push_pref(v, tl,tr);
    push_suff(v, tl, tr);
    if (l > tr || r < tl) return 0;
    if (l <= tl && tr <= r) {
        return tree[v];
    }
    int tm = (tl + tr) / 2;
    return get(2 * v + 1, tl, tm, l, r) + get(2 * v + 2, tm + 1, tr, l, r);
}

int get2 (int v, int tl, int tr ,int l, int r) {
    push_pref(v, tl,tr);
    push_suff(v, tl,tr);
    if (l > tr || r < tl) return 0;
    if (l <= tl && tr <= r) {
        return tree2[v];
    }
    int tm = (tl + tr) / 2;
    return get2(2 * v + 1, tl, tm, l, r) + get2(2 * v + 2, tm + 1, tr, l, r);
}

pair<int, int> get_mx (int v, int tl, int tr, int l, int r) {
    if (l > tr || r < tl) return {0, -1};
    if (l <= tl && tr <= r) {
        return tree_mx[v];
    }
    int tm = (tl + tr) / 2;
    return max(get_mx(2 * v + 1, tl, tm, l, r), get_mx(2 * v + 2, tm + 1, tr, l, r));
}

int help[N];

void upd (int k, int val) {
    for (; k < N; k += (k & - k)) {
        help[k] += val;
    }
}

int get_obr (int k) {
    int sum = 0;
    for (;k > 0; k -= (k & -k)) {
        sum += help[k];
    }
    return sum;
}





void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 1; i <= n; ++i) {
        upd(i, 1);
    }

    vector<int> pr;
    pr.push_back(a[0]);
    for (int i = 1; i < n; ++i) pr.push_back(a[i] + pr.back());
    vector<int> was(n);
    for (int i = 0; i < n; ++i) was[i] = i;
    build(0, 0, N);
    for (int _ = 0; _ < n - 1; ++_) {
        int k;
        cin >> k;
        int l = 0, r = n;
        while (r - l > 1) {
            int mid = (r + l) / 2;
            int sum = get_obr(mid);
            if (sum >= k) {
                r = mid;
            } else {
                l = mid;
            }
        }
        int cur = r;
        l = 0, r = n;
        while (r - l > 1) {
            int mid = (r + l) / 2;
            int sum = get_obr(mid);
            if (sum >= k + 1) {
                r = mid;
            } else {
                 l = mid;
            }
        }
        int nxt = r;
        upd(nxt, -1);
        --cur, --nxt;
        int left_cur = cur, right_cur = was[cur];
        int left_nxt = nxt, right_nxt = was[nxt];
        pair<int, int> lol_cur = get_mx(0, 0, N, left_cur, right_cur);
        int pos_cur = lol_cur.second, mx_cur = lol_cur.first;
        pair<int, int> lol_nxt = get_mx(0, 0, N, left_nxt, right_nxt);
        int pos_nxt = lol_nxt.second, mx_nxt = lol_nxt.first;
        int pos_mx = get_mx(0, 0, N, left_cur, right_nxt).second;
        l = left_nxt, r = right_nxt + 1;
        while (r - l > 1) {
            int mid = (r + l) / 2;
            int mx = get_mx(0, 0, N, left_nxt, mid).first;
            if (mx > mx_cur) {
                r = mid;
            } else {
                l = mid;
            }
        }
        int check = get_mx(0, 0, N, left_nxt, l).first;
        //cout << left_nxt << ' ' << right_nxt << ' ' << l << ' ' << mx_cur << ' ' << check << '\n';
        if (check <= mx_cur) {
            update(0, 0, N, left_nxt, l, mx_cur);
        }
        l = left_cur - 1, r = right_cur;
        while (r - l > 1) {
            int mid = (r + l) / 2;
            int mx = get_mx(0, 0, N, mid, right_nxt).first;
            if (mx > mx_nxt) {
                l = mid;
            } else {
                r = mid;
            }
        }
        check = get_mx(0, 0, N, r, right_cur).first;
        // cout << left_cur << ' ' << right_cur << ' ' << r << ' ' << mx_nxt << ' ' << check << '\n';
        if (check <= mx_nxt) {
            update2(0, 0, N, r, right_cur, mx_nxt);
        }
        int res = pr[right_nxt] - (left_cur == 0 ? 0 : pr[left_cur - 1]);
        //cout << res << ' ';
        res -= (get(0, 0, N, left_cur, pos_mx) + get2(0, 0, N, pos_mx + 1, right_nxt));
        cout << -res << '\n';
         was[left_cur] = was[nxt];
    //
    //
    //
    }

}

// 8
// 9 1 8 1 5 2 3 6
// 3 3 1 3 3 2 1

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
}
